﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.IO;

namespace HeuristicLab.Update.Service {
  [ServiceContract]
  public interface IUpdateLocation {

    [OperationContract]
    IEnumerable<PluginInformation> GetAvailablePluginsByName(string name);

    [OperationContract]
    IEnumerable<byte[]> GetPluginFiles(PluginInformation info);
  }


  [DataContract]
  public class PluginInformation {
    private string name;
    [DataMember]
    public string Name {
      get { return name; }
      set { name = value; }
    }
    private Version version;
    [DataMember]
    public Version Version {
      get { return version; }
      set { version = value; }
    }
    private DateTime buildDate;
    [DataMember]
    public DateTime BuildDate {
      get { return buildDate; }
      set { buildDate = value; }
    }

    public PluginInformation(string name, Version version, DateTime buildDate)
      : base() {
      this.name = name;
      this.version = version;
      this.buildDate = buildDate;
    }
  }
}
